package org.eclipse.jdt.internal.compiler.ast;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.internal.compiler.ast.Statement;
import org.eclipse.jdt.internal.compiler.ast.SubRoutineStatement;
import org.eclipse.jdt.internal.compiler.codegen.BranchLabel;
import org.eclipse.jdt.internal.compiler.codegen.CodeStream;
import org.eclipse.jdt.internal.compiler.lookup.BlockScope;
import org.eclipse.jdt.internal.compiler.lookup.Scope;

public abstract class BranchStatement extends Statement {
  public char[] label;
  
  public BranchLabel targetLabel;
  
  public SubRoutineStatement[] subroutines;
  
  public int initStateIndex = -1;
  
  public BranchStatement(char[] label, int sourceStart, int sourceEnd) {
    this.label = label;
    this.sourceStart = sourceStart;
    this.sourceEnd = sourceEnd;
  }
  
  public void generateCode(BlockScope currentScope, CodeStream codeStream) {
    if ((this.bits & Integer.MIN_VALUE) == 0)
      return; 
    int pc = codeStream.position;
    if (this.subroutines != null)
      for (int i = 0, max = this.subroutines.length; i < max; i++) {
        SubRoutineStatement sub = this.subroutines[i];
        boolean didEscape = sub.generateSubRoutineInvocation(currentScope, codeStream, this.targetLabel, this.initStateIndex, null);
        if (didEscape) {
          codeStream.recordPositionsFrom(pc, this.sourceStart);
          SubRoutineStatement.reenterAllExceptionHandlers(this.subroutines, i, codeStream);
          if (this.initStateIndex != -1) {
            codeStream.removeNotDefinitelyAssignedVariables((Scope)currentScope, this.initStateIndex);
            codeStream.addDefinitelyAssignedVariables((Scope)currentScope, this.initStateIndex);
          } 
          return;
        } 
      }  
    codeStream.goto_(this.targetLabel);
    codeStream.recordPositionsFrom(pc, this.sourceStart);
    SubRoutineStatement.reenterAllExceptionHandlers(this.subroutines, -1, codeStream);
    if (this.initStateIndex != -1) {
      codeStream.removeNotDefinitelyAssignedVariables((Scope)currentScope, this.initStateIndex);
      codeStream.addDefinitelyAssignedVariables((Scope)currentScope, this.initStateIndex);
    } 
  }
  
  public void resolve(BlockScope scope) {}
}
